Index: trunk/SophyaLib/Manual/modifs.tex
===================================================================
--- trunk/SophyaLib/Manual/modifs.tex	(revision 3754)
+++ trunk/SophyaLib/Manual/modifs.tex	(revision 3817)
@@ -45,5 +45,5 @@
 {\Large \bf SOPHYA Change Log \\[1mm]
   Liste des modifications de SOPHYA } \\[5mm] 
-{\large Septembre 2003 - Septembre 2008 } \\[25mm]
+{\large Septembre 2003 - Septembre 2010 } \\[25mm]
 Liste des tags et dates : \\[5mm]
 {\large 
@@ -64,4 +64,5 @@
 V = 2.125  &   \hspace{10mm}  &  Sept-Oct 2008 - NO tag  \\
 V = 2.140  &   \hspace{10mm}  &  Sept-Oct 2009 - NO tag  \\
+V = 2.150  &   \hspace{10mm}  &  Mars 2010 - NO tag  \\
 
 \end{tabular}
@@ -92,4 +93,5 @@
 \titre{BuildMgr}
 \begin{itemize}
+\item[\rond] Juillet 2010 : Ajout de l'option {\tt -arch32} de compilation en 32 bits pour linux
 \item[\rond] Mars 2010 : Ajout de l'option {\tt -ldble128} dans le script configure pour la gestion conditionnelle 
 du flag compilation {\bf SO\_LDBLE128 } dans machdefs.h.  Ce flag active la dclaration des nombres en 
@@ -111,4 +113,8 @@
 \titre{TArray}
 \begin{itemize}
+\item[\rond] Juillet 2010 : Introduction des classes de matrices carres spciales (SSQM : Special Square Matrix).
+Suppression de la classe  {\bf TriangularMatrix$<$T$>$} et du fichier {\tt triangmtx.h }.  
+Voir ci-dessous pour plus d'information.
+
 \item[\rond] Mars 2010 : Prise en charge de float 128 bits  ({\tt r\_16}) et 
 {\tt complex$<$ r\_16 $>$} dans les TArray, TMatrix et TVector.
@@ -121,6 +127,39 @@
 \end{itemize}
 
+\soustitre{SSQM: Special Square Matrix}
+Classes de matrices carrees speciales avec la hirarchie dcrite ci-dessous. Ces classes ont t dveloppes au 
+printemps 2009 et introduites dans SOPHYA  l't 2010.
+\begin{verbatim}
+AnyDataObj -- SpecialSquareMatrix<T> -- DiagonalMatrix<T>
+                                     -- LowerTriangularMatrix<T>
+                                     -- SymmetricMatrix<T>
++ classe gestionnaire PPF FIO_SpecialSquareMatrix<T> 
+\end{verbatim} 
+
+Fichiers ajouts dans TArray/ : \\
+{\tt spesqmtx.h spesqmtx\_tsnl.h diagmtx.h trngmtx.h symmtx.h fiospsqmtx.h} \\
+{\tt  spesqmtx.cc fiospsqmtx.cc } \\
+Fichier {\tt triangmtx.h } a t supprim (classe {\bf TriangularMatrix$<$T$>$ } 
+remplace par {\bf LowerTriangularMatrix$<$T$>$} . \\
+Programme test {\tt tssqmx.cc} ajout dans le module Tests/. 
+Pour vrifier le code, faire : \\
+{\tt csh> tssqmx d ( tssqmx t , s ) } \\[1mm]
+Pour ajouter d'autres classes de matrices carres: 
+\begin{enumerate}
+\item Dclarer si besoin le type ds enum SpSqMtxType (fichier spesqmtx.h)
+\item Recopier diagmtx.h en mtxnouvcarre.h (enfin, le nouveau nom de fichier/classe)
+\item changer le nom de la classe ds mtxnouvcarre.h
+\item Repasser  travers les mthodes et constructeurs en particulier SetSize() et les 
+accs aux lments 
+\item Modifier ou simplement supprimer les mthodes (et oprateurs) de multiplication de matrices
+\item Dans le fichier fiospsqmtx.cc, prvoir le dynamic\_cast / new $<$MatriceCarre$>$ dans : 
+\hspace{5mm} FIO\_SpecialSquareMatrix(const SpecialSquareMatrix$<$T$>$ \& obj) \\
+\hspace{5mm} FIO\_SpecialSquareMatrix$<$T$>$::ReadSelf(PInPersist\& is)
+\end{enumerate}
+
+
 \titre{SkyMap/Samba}
 \begin{itemize}
+\item[\rond] Juillet 2010 : Adaptation  la nouvelle classe {\bf LowerTriangularMatrix$<$T$>$} 
 \item[\rond] Sep 2008 : Nettoyage cosmetique ds lambdaBuilder.h .cc - {\bf A FAIRE :} rendre 
 LambdaLMBuilder thread-safe.
@@ -145,10 +184,11 @@
 \item[\rond] Dec 2009: Introduction des classes {\bf ParallelTaskInterface, ParallelTaskFunction}
 et {\bf ParalExThread, ParallelExecutor} afin de faciliter l'criture de code avec excution de 
-fonctions en parallle dans des threads. Voir les fichier {\tt SysTools/parlex.h .cc} 
-et {\tt Tests/tparlex.cc}.
+fonctions en parallle dans des threads. \\
+Voir les fichier {\tt SysTools/parlex.h .cc}  et {\tt Tests/tparlex.cc}.
 \item[\rond] Fev 2009 : Amlioration conversion double->string pour viter la perte de 
 prcision lors des valuations avec les variables de l'interprteur (commander.cc). 
 \item[\rond] Fev 2009 : Amlioration de la classe {\bf Timer}, prcision time-elapsed 
-par utilisation {\tt gettimeofday(...)} au lieu de {\tt time()}, 
+par utilisation de \\ 
+{\tt gettimeofday(...)} au lieu de {\tt time()}, \\
 amlioration calcul temps cpu pour jobs tres long (lorsque TCPU dpasse le maximum $2^{32}$.
 \end{itemize}