Index: trunk/SophyaLib/SkyMap/localmap.cc
===================================================================
--- trunk/SophyaLib/SkyMap/localmap.cc	(revision 3786)
+++ trunk/SophyaLib/SkyMap/localmap.cc	(revision 3836)
@@ -1,7 +1,9 @@
 #include "sopnamsp.h"
-#include "localmap.h"
 #include "smathconst.h"
 #include <complex>
 #include "fiondblock.h"
+
+#define LOCALMAP_CC_BFILE  // avoid extern template declarations 
+#include "localmap.h"
 
 #include <string.h>
Index: trunk/SophyaLib/SkyMap/localmap.h
===================================================================
--- trunk/SophyaLib/SkyMap/localmap.h	(revision 3786)
+++ trunk/SophyaLib/SkyMap/localmap.h	(revision 3836)
@@ -352,4 +352,13 @@
     return result; }
 
+//--------- extern template declarations (if needed) -----------
+#if defined ( NEED_EXT_DECL_TEMP ) && !defined( LOCALMAP_CC_BFILE )
+extern template class LocalMap<int_4>;
+extern template class LocalMap<r_8>;
+extern template class LocalMap<r_4>;
+extern template class LocalMap< complex<r_8> >;
+extern template class LocalMap< complex<r_4> >;
+#endif  // Fin de if defined ( NEED_EXT_DECL_TEMP )
+
 
 
Index: trunk/SophyaLib/SkyMap/sphereecp.cc
===================================================================
--- trunk/SophyaLib/SkyMap/sphereecp.cc	(revision 3786)
+++ trunk/SophyaLib/SkyMap/sphereecp.cc	(revision 3836)
@@ -1,5 +1,7 @@
 #include "sopnamsp.h"
+#include <math.h>
+
+#define SPHEREECP_CC_BFILE  // avoid extern template declarations 
 #include "sphereecp.h"
-#include <math.h>
 
 /*!
Index: trunk/SophyaLib/SkyMap/sphereecp.h
===================================================================
--- trunk/SophyaLib/SkyMap/sphereecp.h	(revision 3786)
+++ trunk/SophyaLib/SkyMap/sphereecp.h	(revision 3836)
@@ -161,4 +161,13 @@
 };
 
+//--------- extern template declarations (if needed) -----------
+#if defined ( NEED_EXT_DECL_TEMP ) && !defined( SPHEREECP_CC_BFILE )
+extern template class SphereECP<int_4>;
+extern template class SphereECP<r_4>;
+extern template class SphereECP<r_8>;
+extern template class SphereECP< complex<r_4> >;
+extern template class SphereECP< complex<r_8> >;
+#endif  // Fin de if defined ( NEED_EXT_DECL_TEMP )
+
 
 }// Fin du namespace
Index: trunk/SophyaLib/SkyMap/spherehealpix.cc
===================================================================
--- trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 3786)
+++ trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 3836)
@@ -6,6 +6,8 @@
 #include "pexceptions.h"
 #include "fiondblock.h"
+#include "strutil.h"
+
+#define SPHEREHEALPIX_CC_BFILE  // avoid extern template declarations 
 #include "spherehealpix.h"
-#include "strutil.h"
 
 extern "C" 
Index: trunk/SophyaLib/SkyMap/spherehealpix.h
===================================================================
--- trunk/SophyaLib/SkyMap/spherehealpix.h	(revision 3786)
+++ trunk/SophyaLib/SkyMap/spherehealpix.h	(revision 3836)
@@ -306,4 +306,14 @@
     return result; }
 
+//--------- extern template declarations (if needed) -----------
+#if defined ( NEED_EXT_DECL_TEMP ) && !defined( SPHEREHEALPIX_CC_BFILE )
+extern template class SphereHEALPix<uint_2>;
+extern template class SphereHEALPix<int_4>;
+extern template class SphereHEALPix<r_8>;
+extern template class SphereHEALPix<r_4>;
+extern template class SphereHEALPix< complex<r_4> >;
+extern template class SphereHEALPix< complex<r_8> >;
+#endif  // Fin de if defined ( NEED_EXT_DECL_TEMP )
+
 } // Fin du namespace
 
Index: trunk/SophyaLib/SkyMap/spherethetaphi.cc
===================================================================
--- trunk/SophyaLib/SkyMap/spherethetaphi.cc	(revision 3786)
+++ trunk/SophyaLib/SkyMap/spherethetaphi.cc	(revision 3836)
@@ -1,8 +1,10 @@
 #include "sopnamsp.h"
-#include "spherethetaphi.h"
 #include "smathconst.h"
 #include <complex>
 #include "fiondblock.h"
 #include <iostream>
+
+#define SPHERETHETAPHI_CC_BFILE  // avoid extern template declarations 
+#include "spherethetaphi.h"
 
 
Index: trunk/SophyaLib/SkyMap/spherethetaphi.h
===================================================================
--- trunk/SophyaLib/SkyMap/spherethetaphi.h	(revision 3786)
+++ trunk/SophyaLib/SkyMap/spherethetaphi.h	(revision 3836)
@@ -315,4 +315,13 @@
 
 
+//--------- extern template declarations (if needed) -----------
+#if defined ( NEED_EXT_DECL_TEMP ) && !defined( SPHERETHETAPHI_CC_BFILE )
+extern template class SphereThetaPhi<int_4>;
+extern template class SphereThetaPhi<r_8>;
+extern template class SphereThetaPhi<r_4>;
+extern template class SphereThetaPhi< complex<r_4> >;
+extern template class SphereThetaPhi< complex<r_8> >;
+#endif  // Fin de if defined ( NEED_EXT_DECL_TEMP )
+
 } // Fin du namespace
 