Index: trunk/SophyaLib/Manual/piahelp.tex
===================================================================
--- trunk/SophyaLib/Manual/piahelp.tex	(revision 3615)
+++ trunk/SophyaLib/Manual/piahelp.tex	(revision 3839)
@@ -12,4 +12,5 @@
 \item {\bf Func Plot }  (p. \pageref{FuncZPlot}) 
 \item {\bf Graphic-Elts }  (p. \pageref{GraphicZElts}) 
+\item {\bf GraphicExport }  (p. \pageref{GraphicExport}) 
 \item {\bf Graphics }  (p. \pageref{Graphics}) 
 \item {\bf Obj. Display }  (p. \pageref{ObjZZDisplay}) 
@@ -107,5 +108,5 @@
 saveall & p. \pageref{saveall}  & savefits & p. \pageref{savefits}  & savelist & p. \pageref{savelist}  \\  
 saveobjs & p. \pageref{saveobjs}  & saveppf & p. \pageref{saveppf}  & scanfits & p. \pageref{scanfits}  \\  
-swfitstable & p. \pageref{swfitstable}  & vecfrascii & p. \pageref{vecfrascii}  & writefits & p. \pageref{writefits} \\  
+swfitstable & p. \pageref{swfitstable}  & vecfrascii & p. \pageref{vecfrascii}  & writefits & p. \pageref{writefits}  \\  
 \end{tabular} 
 \end{center} 
@@ -134,9 +135,20 @@
 \begin{tabular}{llllll} 
 addarc & p. \pageref{addarc}  & addarca & p. \pageref{addarca}  & addarrow & p. \pageref{addarrow}  \\  
-addcirc & p. \pageref{addcirc}  & addctext & p. \pageref{addctext}  & addfarc & p. \pageref{addfarc}  \\  
-addfarca & p. \pageref{addfarca}  & addfcirc & p. \pageref{addfcirc}  & addfoval & p. \pageref{addfoval}  \\  
-addfpoly & p. \pageref{addfpoly}  & addfrect & p. \pageref{addfrect}  & addline & p. \pageref{addline}  \\  
-addmarker & p. \pageref{addmarker}  & addoval & p. \pageref{addoval}  & addpoly & p. \pageref{addpoly}  \\  
-addrect & p. \pageref{addrect}  & addtext & p. \pageref{addtext}  &   &   \\  
+addaxelabels & p. \pageref{addaxelabels}  & addcirc & p. \pageref{addcirc}  & addctext & p. \pageref{addctext}  \\  
+addfarc & p. \pageref{addfarc}  & addfarca & p. \pageref{addfarca}  & addfcirc & p. \pageref{addfcirc}  \\  
+addfoval & p. \pageref{addfoval}  & addfpoly & p. \pageref{addfpoly}  & addfrect & p. \pageref{addfrect}  \\  
+addline & p. \pageref{addline}  & addmarker & p. \pageref{addmarker}  & addoval & p. \pageref{addoval}  \\  
+addpoly & p. \pageref{addpoly}  & addrect & p. \pageref{addrect}  & addtext & p. \pageref{addtext}  \\  
+addtitle & p. \pageref{addtitle}  & setaxelabels & p. \pageref{setaxelabels}  & settitle & p. \pageref{settitle}  \\  
+\end{tabular} 
+\end{center} 
+\vspace{6mm} 
+\begin{center} 
+ \rule{2cm}{0.5mm} \makebox[60mm]{{ \bf GraphicExport } help group} \rule{2cm}{0.5mm} \\ 
+\vspace{3mm} 
+\begin{tabular}{llllll} 
+imagcmap2eps & p. \pageref{imagcmap2eps}  & imagcmap2ps & p. \pageref{imagcmap2ps}  & psclosefile & p. \pageref{psclosefile}  \\  
+psgetfilename & p. \pageref{psgetfilename}  & pssetfilename & p. \pageref{pssetfilename}  & w2eps & p. \pageref{w2eps}  \\  
+w2ps & p. \pageref{w2ps}  & wdg2rgb & p. \pageref{wdg2rgb}  & win2rgb & p. \pageref{win2rgb}  \\  
 \end{tabular} 
 \end{center} 
@@ -147,11 +159,8 @@
 \begin{tabular}{llllll} 
 PIConsole & p. \pageref{PIConsole}  & PIDraw3DWdg & p. \pageref{PIDraw3DWdg}  & PIImage & p. \pageref{PIImage}  \\  
-PIScDrawWdg & p. \pageref{PIScDrawWdg}  & Windows & p. \pageref{Windows}  & addaxelabels & p. \pageref{addaxelabels}  \\  
-addtitle & p. \pageref{addtitle}  & drpanel & p. \pageref{drpanel}  & graphicatt & p. \pageref{graphicatt}  \\  
-imagcmap2eps & p. \pageref{imagcmap2eps}  & imagcmap2ps & p. \pageref{imagcmap2ps}  & newwin & p. \pageref{newwin}  \\  
-psclosefile & p. \pageref{psclosefile}  & psgetfilename & p. \pageref{psgetfilename}  & pssetfilename & p. \pageref{pssetfilename}  \\  
-setaxelabels & p. \pageref{setaxelabels}  & setaxesatt & p. \pageref{setaxesatt}  & setinsetlimits & p. \pageref{setinsetlimits}  \\  
-settitle & p. \pageref{settitle}  & stacknext & p. \pageref{stacknext}  & w2eps & p. \pageref{w2eps}  \\  
-w2ps & p. \pageref{w2ps}  & zone & p. \pageref{zone}  &   &   \\  
+PIScDrawWdg & p. \pageref{PIScDrawWdg}  & Windows & p. \pageref{Windows}  & drpanel & p. \pageref{drpanel}  \\  
+graphicatt & p. \pageref{graphicatt}  & newwin & p. \pageref{newwin}  & setaxesatt & p. \pageref{setaxesatt}  \\  
+setdefafsz & p. \pageref{setdefafsz}  & setinsetlimits & p. \pageref{setinsetlimits}  & stacknext & p. \pageref{stacknext}  \\  
+zone & p. \pageref{zone}  &   &  &  &   \\  
 \end{tabular} 
 \end{center} 
@@ -165,6 +174,6 @@
 imagnav & p. \pageref{imagnav}  & nt2d & p. \pageref{nt2d}  & nt2dci & p. \pageref{nt2dci}  \\  
 nt2dcn & p. \pageref{nt2dcn}  & nt2dvec & p. \pageref{nt2dvec}  & nt3d & p. \pageref{nt3d}  \\  
-ntcont & p. \pageref{ntcont}  & surf & p. \pageref{surf}  & textdrawer & p. \pageref{textdrawer}  \\  
-vecplot & p. \pageref{vecplot}  &   &  &  &   \\  
+ntcont & p. \pageref{ntcont}  & pirgbdisp & p. \pageref{pirgbdisp}  & surf & p. \pageref{surf}  \\  
+textdrawer & p. \pageref{textdrawer}  & vecplot & p. \pageref{vecplot}  &   &   \\  
 \end{tabular} 
 \end{center} 
@@ -343,5 +352,6 @@
 \end{verbatim} 
 \subsection{CxxExecutorCmd} \label{CxxExecutorCmd} 
-\noindent 
+Commands for c++ codelt on the fly compilation and execution 
+ \\[2mm]  \noindent 
 \piacommand{c++args} \label{cZZargs} 
 \begin{verbatim} 
@@ -463,5 +473,9 @@
 \end{verbatim} 
 \subsection{Expr. Plotting} \label{ExprZZPlotting} 
-\noindent 
+Compute and plot various (c-syntax) expressions of objects 
+Objects are seen as list of structures (n-tuples)
+See ObjectExpressions help item for a list of structure
+fields for the different classes managed by piapp 
+ \\[2mm]  \noindent 
 \piahelpitem{ObjectExpressions} \label{ObjectExpressions} 
 \begin{verbatim} 
@@ -508,8 +522,6 @@
 \piacommand{fillgd2} \label{fillgd2} 
 \begin{verbatim} 
-Creates and Fills a GeneralFitData with 
-            (X=f(Object), Y=g(...), Z=h(...)) ErrZ=k(...)
- Usage: fillgd2 namegfd nameobj f_X() g_Y() h_Z() k_ErrZ() 
-                                [Cut() loop_param]
+Creates and Fills a GeneralFitData with (X=f(Object), Y=g(...), Z=h(...)) ErrZ=k(...)
+ Usage: fillgd1 namegfd nameobj f_X() g_Y() h_Z() k_ErrZ() [Cut() loop_param]
   Related commands: ntloop fillnt ObjectExpressions ...
 \end{verbatim} 
@@ -517,16 +529,13 @@
 \begin{verbatim} 
 Fills a Matrix M(Line=g_Y(Object)+0.5, Col=f_X(Object)+0.5)) =  h_V(Object) 
- Usage: fillmtx namevec nameobj f_X() g_Y() h_V() 
-                [Cut() graphic_attributes loop_param]
+ Usage: fillmtx namevec nameobj f_X() g_Y() h_V() [Cut() graphic_attributes loop_param]
   Related commands: fillvec fillnt ObjectExpressions ...
 \end{verbatim} 
 \piacommand{fillnt} \label{fillnt} 
 \begin{verbatim} 
-Creates and Fills an NTuple(x,y,z,t) with 
-            (X=f(Object),Y=g(...),Z=h(...),T=k(...))
+Creates and Fills an NTuple(x,y,z,t) with (X=f(Object),Y=g(...),Z=h(...),T=k(...))
  Usage: fillnt nameobj f_X() g_Y() h_Z() k_T() [Cut() nameNt loop_param]
   Related commands: ntloop plot2d projh1d projh2d projprof 
-  Related commands: fillvec fillmtx ntloop exptovec fillgd1 
-                    fillgd2 ObjectExpressions ...
+  Related commands: fillvec fillmtx ntloop exptovec fillgd1 fillgd2 ObjectExpressions ...
 \end{verbatim} 
 \piacommand{fillvec} \label{fillvec} 
@@ -554,9 +563,8 @@
 \begin{verbatim} 
 Loops over an Object NTupleInterface calling a function from a C-file 
-and optionaly fills an NTuple(x,y,z,t) with 
-     (X=f(Object),Y=g(...),Z=h(...),T=k(...))
+and optionaly fills an NTuple(x,y,z,t) with (X=f(Object),Y=g(...),Z=h(...),T=k(...))
  Usage: ntloop nameobj CFileName FuncName [NtupleName loop_param]
-  Related commands: fillvec fillmtx fillnt fillgd1 fillgd2 
-  Related commands: exptovec ntexpcfile fillnt ObjectExpressions ...
+  Related commands: fillvec fillmtx fillnt fillgd1 fillgd2 exptovec ObjectExpressions ...
+  Related commands: ntexpcfile fillnt
 \end{verbatim} 
 \piacommand{plot2d} \label{plot2d} 
@@ -575,6 +583,5 @@
 \begin{verbatim} 
 Plots (2D) Y=g(Object) vs. X=f(Object) with error bars eX/Y=f_ErrX/Y(Object) 
- Usage: plot2de nameobj f_X() g_Y() f_ErrX() f_ErrY() [f_Cut() 
-                graphic_attributes loop_param]
+ Usage: plot2de nameobj f_X() g_Y() f_ErrX() f_ErrY() [f_Cut() graphic_attributes loop_param]
   Related commands: plot2d plot2dw plot3d ObjectExpressions ...
 \end{verbatim} 
@@ -612,6 +619,5 @@
 \begin{verbatim} 
 Projects (X=f(Object),Y=g(Object)) with weight WT=h(Object) into a 2D histogram 
- Usage: projh2d nameh2d nameobj f_X() g_Y() [h_WT()=1. Cut() 
-                graphic_attributes loop_param]
+ Usage: projh2d nameh2d nameobj f_X() g_Y() [h_WT()=1. Cut() graphic_attributes loop_param]
    Histo2D nameh2d is created if necessary 
   Related commands: projh1d projprof ObjectExpressions ...
@@ -620,11 +626,10 @@
 \begin{verbatim} 
 Projects (X=f(Object),Y=g(Object)) with weight WT=h(Object) into a profile histogram 
- Usage: projprof nameprof nameobj f_X() g_Y() [h_WT()=1. Cut() 
-                 graphic_attributes loop_param]
+ Usage: projprof nameprof nameobj f_X() g_Y() [h_WT()=1. Cut() graphic_attributes loop_param]
    HProf nameprof is created if necessary 
   Related commands: projh1d projh2d ObjectExpressions ...
 \end{verbatim} 
 \subsection{External Modules} \label{ExternalZModules} 
-Dynamic load (shared object modules) management command group 
+Dynmamic shared library load (DLL) and external (add-on) module management 
  \\[2mm]  \noindent 
 \piacommand{call} \label{call} 
@@ -768,7 +773,9 @@
 \begin{verbatim} 
 savefits: alias for writefits 
+
 \end{verbatim} 
 \piacommand{savelist} \label{savelist} 
 \begin{verbatim} 
+
  Usage: savelist objname1 [objname2 ...] filename
   Related commands: saveobj openppf
@@ -984,6 +991,6 @@
 \begin{verbatim} 
 Displays a function z=f(x,y) from a C-file (Fills a matrix with function values)
- Usage: func2dff C-FileName FunctionName xmin xmax nptx ymin ymax npty [gr_att]
-Related commands: func funcff func2d 
+ Usage: func2dff C-FileName FunctionName xmin xmax nptx ymin ymax npty [graphic_attributes]
+  Related commands: func funcff func2d 
 \end{verbatim} 
 \piacommand{funcff} \label{funcff} 
@@ -994,5 +1001,6 @@
 \end{verbatim} 
 \subsection{Graphic-Elts} \label{GraphicZElts} 
-\noindent 
+Simple graphic objects (lines, circles, text...) creation and display 
+ \\[2mm]  \noindent 
 \piacommand{addarc} \label{addarc} 
 \begin{verbatim} 
@@ -1025,4 +1033,8 @@
   Related commands: addline addtext addrect addfrect 
        addmarker addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt
+\end{verbatim} 
+\piacommand{addaxelabels} \label{addaxelabels} 
+\begin{verbatim} 
+Set the X and Y axis labels for the current 2D graphic object   alias for setaxelabels 
 \end{verbatim} 
 \piacommand{addcirc} \label{addcirc} 
@@ -1177,4 +1189,72 @@
       addcirc addfcirc addarc addfrac addpoly addfpoly settitle graphicatt
 \end{verbatim} 
+\piacommand{addtitle} \label{addtitle} 
+\begin{verbatim} 
+Set the title string (top title / bottom title) 
+   alias for settitle 
+\end{verbatim} 
+\piacommand{setaxelabels} \label{setaxelabels} 
+\begin{verbatim} 
+Set the X and Y axis labels for the current 2D graphic object 
+
+  Usage: setaxelabels xLabel yLabel [ColorFntAtt]
+  Related commands: settitle addtext graphicatt
+\end{verbatim} 
+\piacommand{settitle} \label{settitle} 
+\begin{verbatim} 
+Set the title string (top title / bottom title) for the current graphic object
+  Usage: settitle TopTitle [BottomTitle] [fontAtt]
+  Related commands: addtext graphicatt
+\end{verbatim} 
+\subsection{GraphicExport} \label{GraphicExport} 
+Commands to export graphics (widget/windows in postscript or PI-RGB image files 
+ \\[2mm]  \noindent 
+\piacommand{imagcmap2eps} \label{imagcmap2eps} 
+\begin{verbatim} 
+imagcmap2eps: Current Image+ColorMap To EncapsulatedPostScript 
+Usage: imagcmap2eps EPSFileName
+\end{verbatim} 
+\piacommand{imagcmap2ps} \label{imagcmap2ps} 
+\begin{verbatim} 
+w2ps: Current Image+ColorMap To PostScript 
+Usage: imagcmap2ps 
+\end{verbatim} 
+\piacommand{psclosefile} \label{psclosefile} 
+\begin{verbatim} 
+psclosefile: close current postscript file 
+Usage: w2psclosefile 
+\end{verbatim} 
+\piacommand{psgetfilename} \label{psgetfilename} 
+\begin{verbatim} 
+psgetfilename: Prints current PostScript file name 
+Usage: psgetfilename 
+\end{verbatim} 
+\piacommand{pssetfilename} \label{pssetfilename} 
+\begin{verbatim} 
+pssetfilename: Sets current PostScript file name
+Usage: pssetfilename FileName 
+\end{verbatim} 
+\piacommand{w2eps} \label{w2eps} 
+\begin{verbatim} 
+w2eps: Current Window To EncapsulatedPostScript 
+Usage: w2eps EPSFileName
+\end{verbatim} 
+\piacommand{w2ps} \label{w2ps} 
+\begin{verbatim} 
+w2ps: Current Window To PostScript 
+Usage: w2ps 
+\end{verbatim} 
+\piacommand{wdg2rgb} \label{wdg2rgb} 
+\begin{verbatim} 
+ Export the current widget to a PI-RGB file (.rgb)
+ Usage : wdg2rgb PI-RGB_FileName  (.rgb)
+ Related commands: pirgbdisp  win2rgb 
+\end{verbatim} 
+\piacommand{win2rgb} \label{win2rgb} 
+\begin{verbatim} 
+ Export the current window to a PI-RGB file (.rgb)
+ Usage : win2rgb PI-RGB_FileName  (.rgb)
+ Related commands: pirgbdisp  wdg2rgb 
+\end{verbatim} 
 \subsection{Graphics} \label{Graphics} 
 Basic graphics and object display commands 
@@ -1195,5 +1275,5 @@
 o <Ctl>E : Command editing -> Goto the end of line 
 o <Ctl>K : Command editing -> Clear to the end of line 
-o <Ctl>C : Stop/break command execution by PIACmd/Commander
+o <Ctl>C : Stop/break command execution by PIACmd/Commander 
 o Cursor left,right : Command editing -> Move cursor 
 o Cursor Up,Down : recall command from history buffer 
@@ -1239,6 +1319,5 @@
 o <Alt>D : Shows the drawer manipulation pop-up menu 
 o <Alt>V : Copy/Paste / Text paste at the current cursor position 
-o <Alt>C : Copy/Paste / Copies the selected region content as text 
-                        in the copy/paste buffer 
+o <Alt>C : Copy/Paste / Copies the selected regions content as text in the copy/paste buffer 
 o <Alt>X : Show/Hide the Cut Window 
 o <Alt>Z : Removes added graphic elements (handled by BaseDrawer - 0) 
@@ -1296,13 +1375,4 @@
 
   Related commands: newwin zone stacknext graphicatt setinsetlimits
-\end{verbatim} 
-\piacommand{addaxelabels} \label{addaxelabels} 
-\begin{verbatim} 
-Set the X and Y axis labels for the current 2D graphic object   alias for setaxelabels 
-\end{verbatim} 
-\piacommand{addtitle} \label{addtitle} 
-\begin{verbatim} 
-Set the title string (top title / bottom title) 
-   alias for settitle 
 \end{verbatim} 
 \piacommand{drpanel} \label{drpanel} 
@@ -1348,5 +1418,5 @@
                 midas_pastel midas_heat midas_rainbow3 midas_bluered
                 midas_bluewhite midas_redwhite
-                multicol16 multicol64
+                multicol16 multicol64 rgb216cm rgb512cm rgb4096cm
 >> revcmap : reverse colorMap
 >> ZoomFactors :  zoomxN   ex: zoomx1 zoomx2 zoomx3 ...
@@ -1354,8 +1424,10 @@
 >> imagecenter=ix,iy : Position the image in widget
 >> lut=ltyp,min,max : Sets LUT type and min/max
-                   (ltyp=lin/log/sqrt/square)
+                   (ltyp=lin/log/sqrt/square/rgb)
 >> autolut=alt[,ns[,min,max]] : AutoLut method selection 
                    (alt=minmax/meansig/hispeak/histail/hisrng)
 >> invx,invy,exchxy : image axes configuration
+>> cdreal,cdimag,cdphase,cdmod,cdmod2 (default=cdmod): Displayed value
+     for complex arrays (real/imaginary part, phase, module, module^2)
 --- General purpose options:
 >> stat,stats / nsta,nstat,nostat,nostats : Toggle statistic display
@@ -1367,14 +1439,4 @@
    Related commands: setaxesatt setinsetlimits 
 \end{verbatim} 
-\piacommand{imagcmap2eps} \label{imagcmap2eps} 
-\begin{verbatim} 
-imagcmap2eps: Current Image+ColorMap To EncapsulatedPostScript 
-Usage: imagcmap2eps EPSFileName
-\end{verbatim} 
-\piacommand{imagcmap2ps} \label{imagcmap2ps} 
-\begin{verbatim} 
-w2ps: Current Image+ColorMap To PostScript 
-Usage: imagcmap2ps 
-\end{verbatim} 
 \piacommand{newwin} \label{newwin} 
 \begin{verbatim} 
@@ -1383,26 +1445,4 @@
     Usage: newwin [nx ny [sizeX sizeY]] 
   Related commands: zone
-\end{verbatim} 
-\piacommand{psclosefile} \label{psclosefile} 
-\begin{verbatim} 
-psclosefile: close current postscript file 
-Usage: w2psclosefile 
-\end{verbatim} 
-\piacommand{psgetfilename} \label{psgetfilename} 
-\begin{verbatim} 
-psgetfilename: Prints current PostScript file name 
-Usage: psgetfilename 
-\end{verbatim} 
-\piacommand{pssetfilename} \label{pssetfilename} 
-\begin{verbatim} 
-pssetfilename: Sets current PostScript file name
-Usage: pssetfilename FileName 
-\end{verbatim} 
-\piacommand{setaxelabels} \label{setaxelabels} 
-\begin{verbatim} 
-Set the X and Y axis labels for the current 2D graphic object 
-
-  Usage: setaxelabels xLabel yLabel [ColorFntAtt]
-  Related commands: settitle addtext graphicatt
 \end{verbatim} 
 \piacommand{setaxesatt} \label{setaxesatt} 
@@ -1424,10 +1464,18 @@
          fixedfontsize: Use font size attribute (BaseDrawer) 
 >> Scale type: linx liny logx logy -> Lin/Log Scales for 2D plots 
->> AxeDirection: Reverse X/Y axe drawing direction
-         revax revay axelr axedu (or axerl/axeud -> revax/revay)
+>> AxeDirection: Reverse X/Y axe drawing direction 
+         revax revay axelr axedu (or axerl/axeud -> revax/revay) 
 >> xylimits=xmin,xmax,ymin,ymax  -> Forces X-Y limits in 2-D plots 
 >> defdrrect=xmin,xmax,ymin,ymax -> Defines drawing rectangle 2-D plots 
           The rectangle is defined as a fraction of the widget size
 
+\end{verbatim} 
+\piacommand{setdefafsz} \label{setdefafsz} 
+\begin{verbatim} 
+Define the Global Default value for PIDrawer AutoFontSize Fraction 
+ Usage: setdefafsz value 
+   0<value<1 : default PIDrawer font size, as a fraction of the widget size
+   Its value can be set by the PIDEFAFSZFRAC environment variable 
+   See also graphic attributes : fixedfontsize autofontsize=frac 
 \end{verbatim} 
 \piacommand{setinsetlimits} \label{setinsetlimits} 
@@ -1439,24 +1487,8 @@
   Related commands: graphicatt /inset
 \end{verbatim} 
-\piacommand{settitle} \label{settitle} 
-\begin{verbatim} 
-Set the title string (top title / bottom title) for the current graphic object
-  Usage: settitle TopTitle [BottomTitle] [fontAtt]
-  Related commands: addtext graphicatt
-\end{verbatim} 
 \piacommand{stacknext} \label{stacknext} 
 \begin{verbatim} 
 Displays the next widget on stack window 
   Usage: stacknext
-\end{verbatim} 
-\piacommand{w2eps} \label{w2eps} 
-\begin{verbatim} 
-w2eps: Current Window To EncapsulatedPostScript 
-Usage: w2eps EPSFileName
-\end{verbatim} 
-\piacommand{w2ps} \label{w2ps} 
-\begin{verbatim} 
-w2ps: Current Window To PostScript 
-Usage: w2ps 
 \end{verbatim} 
 \piacommand{zone} \label{zone} 
@@ -1467,5 +1499,6 @@
 \end{verbatim} 
 \subsection{Obj. Display} \label{ObjZZDisplay} 
-\noindent 
+Most useful commands to view and display objects  
+ \\[2mm]  \noindent 
 \piacommand{bargraph} \label{bargraph} 
 \begin{verbatim} 
@@ -1568,4 +1601,11 @@
     labon : put labels for contours 
 \end{verbatim} 
+\piacommand{pirgbdisp} \label{pirgbdisp} 
+\begin{verbatim} 
+Read and display RGB-image object (PIPixRGBArray) from file 
+ Usage : pirgbdisp PI-RGB_FileName [gr_opt] 
+ gr_opt (def=rgb216cm):zoom, rgb4096cm rgb32768cm lut=rgb[,min,max]
+ Related commands: win2rgb wdg2rgb 
+\end{verbatim} 
 \piacommand{surf} \label{surf} 
 \begin{verbatim} 
@@ -1900,6 +1940,5 @@
 \begin{verbatim} 
 Project a map(double) into a local map(double)
- Usage: map2local map(double) localmap(double) nx,ny angleX,angleY phi0,theta0 
-                  [x0,y0] [angle]
+ Usage: map2local map(double) localmap(double) nx,ny angleX,angleY phi0,theta0 [x0,y0] [angle]
    nx,ny: number of pixels in x(col),y(row) direction
           X-axis==phi, Y-axis==theta
@@ -1988,5 +2027,4 @@
 \subsection{SophyaCmd} \label{SophyaCmd} 
 \noindent 
-
 \piacommand{errorellipse} \label{errorellipse} 
 \begin{verbatim} 
@@ -2008,7 +2046,7 @@
  Usage: setprjmoldefval OutOfMapValue 
 \end{verbatim} 
-
 \subsection{pawCmd} \label{pawCmd} 
-\noindent 
+CERN PAW like expression plotting commands  
+ \\[2mm]  \noindent 
 \piacommand{h/2d/geth} \label{hZ2dZgeth} 
 \begin{verbatim} 